// 
// Copyright (C) 2018, Affordable Indicators <www.affordableindicators.com>.
// Affordable Indicators reserves the right to modify or overwrite this NinjaScript component with each release.
//

//using System;
//using System.Collections.Generic;
//using System.ComponentModel;
//using System.ComponentModel.DataAnnotations;
//using System.Linq;
//using System.Text;
//using System.Threading.Tasks;
//using System.Windows;
//using System.Windows.Input;
//using System.Windows.Media;
//using System.Xml.Serialization;
//using NinjaTrader.Cbi;
//using NinjaTrader.Gui;
//using NinjaTrader.Gui.Chart;
//using NinjaTrader.Gui.SuperDom;
//using NinjaTrader.Data;
//using NinjaTrader.NinjaScript;
//using NinjaTrader.Core.FloatingPoint;
//using NinjaTrader.NinjaScript.DrawingTools;
using SharpDX.DirectWrite; 
//using System.Globalization;

//============
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
//============
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
using System.IO;

using System.Text.RegularExpressions;
using System.Net;
using System.Text;
using System.Globalization;


//This namespace holds Indicators in this folder and is required. Do not change it. 

namespace NinjaTrader.NinjaScript.Indicators
{
	
	
	
	
	[Gui.CategoryOrder("Orders", 1)] 
    [Gui.CategoryOrder("Parameters", 2)]
	[Gui.CategoryOrder("Labels", 3)]
	[Gui.CategoryOrder("SPX", 15)]	
	[Gui.CategoryOrder("SPX/SPY Combo", 16)] 
   [Gui.CategoryOrder("Trigger", 17)] 
	[Gui.CategoryOrder("Zero Gamma", 18)]	
	[Gui.CategoryOrder("Chart Buttons", 20)] 
	
	[TypeConverter("NinjaTrader.NinjaScript.Indicators.SpotGammaConverter")]
	public class SpotGamma : Indicator
	{

		private string ThisName = "SpotGamma";

		
		private int numplots = 10000;
		
		
				private Stroke ThisStroke = new Stroke(Brushes.DarkGreen, DashStyleHelper.Solid, 2);
		private	Stroke ThisStrokeH = new Stroke(Brushes.DarkGreen, DashStyleHelper.Solid, 2);
	
		DateTime FutureStartDate = DateTime.MinValue;
		DateTime LastDate = DateTime.MinValue;
		
		private double MaxV = 0;
		private double MinV = 1000000;
		
		private int RightEdgeBar = 0;
		
		private string ErrorText = string.Empty;
		private System.Windows.Threading.DispatcherTimer timer2;
		private struct Entry
		{

			public DateTime StartDate;
			public string Plot1;
			public double Plot2;
			public string Plot3;
			public string Plot4;
			public string Plot5;
			public double Plot6;
			public double Plot7;
			public double Plot8;
			public double Plot9;			
			public double Plot10;		
			
			public Entry(DateTime startDate, string plot1, double plot2, string plot3, string plot4, string plot5, double plot6, double plot7, double plot8, double plot9, double plot10 ) {this.StartDate = startDate; this.Plot1 = plot1; this.Plot2 = plot2; this.Plot3 = plot3; this.Plot4 = plot4; this.Plot5 = plot5; this.Plot6 = plot6; this.Plot7 = plot7; this.Plot8 = plot8; this.Plot9 = plot9; this.Plot10 = plot10;}
		}
				
       	List<Entry> entries = new List<Entry>();
		private bool Permission = false;
		private string pLastName = string.Empty;
		
		SortedDictionary<DateTime, Entry> DayToValue = new SortedDictionary<DateTime, Entry>();
	
		private void ReadFile ()
		{
			
	
			//Print(DateTime.Now.ToString() + " Read");
			
			string url = "";
			string result = "";
			//string 	machineid = "";
			string 	instrument = "";
			string 	symbol = "";
			string 	module = "";
			string 	location = "";
			string 	filename = "";
			string  totallocation = "";
			string 	contact = "";
			string 	message = "";
			string s1 = "";
			string	s2 = "";
			string	s3 = "";
			string	s4 = "";
			string	s5 = "";
			string	s6 = "";
			string	s7 = "";
			string	s8 = "";
			string	s9 = "";
			string	s10 = "";
			string	s11 = "";
			
			double d1 = 0;
			double	d2 = 0;
			double	d3 = 0;
			double	d4 = 0;
			double	d5 = 0;
			double	d6 = 0;
			double	d7 = 0;
			double	d8 = 0;
			double	d9 = 0;
			double	d10 = 0;
			
			int daysremaining = 0;
			int	warningdays = 0;
				
			// Creates a StreamReader object
			System.IO.StreamReader sr;
			bool CheckLicense = true;
			bool Permission = false;
			
			DateTime StartDate = DateTime.MinValue;
			DateTime ExpireDate = DateTime.MinValue;
			DateTime CurrentDate = DateTime.MinValue;
		

			
			entries = new List<Entry>();
			entries.Clear();
			
		
			CurrentDate = DateTime.Now;
			//machineid = NinjaTrader.Cbi.License.MachineId;
			instrument = Instrument.MasterInstrument.Name;
			symbol = instrument.Substring(0, 2);

			
			location = NinjaTrader.Core.Globals.UserDataDir;
			
			if (!pUseNinjaDir)
				location = pThisLocation;
			
			
			
			string sla =  @"\";
			
			
			//Print(location[pThisLocation.Length-1].ToString());
			
			if (location[pThisLocation.Length-1].ToString() != sla)
				location = location + sla;
			
//			string lastchar = pThisLocation.Substring(pThisLocation.Length-1, 1);
			
//			if (lastchar != @"\")
//				pThisLocation = pThisLocation + @"\";

			filename = pThisPrefix;
			
			if (pUseIName)
				filename = filename + "_" + instrument;
			
			if (!filename.Contains(".csv") && filename != string.Empty)
				filename = filename + ".csv";
			
			
			
			//filename.ends
						
			totallocation = location + filename;

			
totallocation = location + filename;

			
			
			
			
			url = pWebLocation + filename;
			
			if (filename == string.Empty)
				url = pWebLocation;
			
			
			if (pTimeSlicedLeftoverAction == "Web")
			{
				
				
				
				try
				{
					WebClient client = new WebClient();
					result = client.DownloadString(url);
				//	Print(result);
				}
				catch (Exception ex)
				{
					// handle error
					//MessageBox.Show( ex.Message );
					//MessageBox.Show("You must be connected to the Internet to verify your license for TFiAFlow.");
					
					ErrorText = "File '" + filename + "' not found in " + "'"+pWebLocation+"'.  Or you aren't connected to the Internet.";
					
					if (filename == string.Empty)
						ErrorText = "File not found in " + "'"+pWebLocation+"'.  Or you aren't connected to the Internet.";
				}
		
			
			
			
				
			}
			else
			{
					
				
				try
				{
					result = System.IO.File.ReadAllText(totallocation);
					//Print(result);
				}
				catch (Exception ex)
				{
					ErrorText = "File '" + filename + "' not found in " + "'"+location+"'.  Or the file cannot be read.";
					//MessageBox.Show("File Not Found.");
				}
		
					
				
			}
		
		
			
			TotalError = TotalError + ErrorText + "     ";
			
						
		
			
				

			
	// split the string into lines
				string[] lines = Regex.Split(result, "\r\n");	

					// Sets the file the StreamReader will read from
	
				string line = "";
				int lineCounter = 0;
				// Read lines and calculate the current day's OHLC from the file. While loop will go through the whole file.
				while (lineCounter < lines.Length) 
				{
					line = lines[lineCounter];
					// Splits the line at every white space. Places each split into the string array
					string [] split = line.Split(',');
					//Print(line);
					// Creates a counter that will mark which string from the split array we are dealing with
					int splitCounter = 0;
					
					
					
					// For every string inside the newly created string array...
					
					
					
					//if (line != ",,,,,,,,," && !line.Contains("Unique ID"))
					if (lineCounter > 0)
					{
						
							//Print(line);
						foreach (string s in split)
						{

							
							//Print(s);
							//Print(s2);
							
							splitCounter++;
							
							//Print(splitCounter);
							
							switch(splitCounter)       
							{         
								
								
								
								case 1:
									s1 = s;
									
									//DateTime.TryParseExact(s1, "M/d/yyyy", CultureInfo.InvariantCulture, DateTimeStyles.None, out StartDate);
									
									//Print(StartDate.ToString());
									
									break;                  
								case 2:            
									s2 = s;								
									double.TryParse(s2, out d2);
									break;   									        
								case 3:            
									s3 = s;
									
									s3 = s3.Replace("PutWall", "Put Wall");
									s3 = s3.Replace("VolTrig", "Vol Trigger");
									//s3 = s3.Replace(":", "");
									s3 = s3.Replace("L1 ", "L1: ");
									s3 = s3.Replace("L2 ", "L2: ");
									s3 = s3.Replace("L3 ", "L3: ");
									s3 = s3.Replace("L4 ", "L4: ");
									
									//double.TryParse(s3, out d2);
									break;       
								case 4:   
									s4 = s.ToUpper();
									//double.TryParse(s4, out d3);
									break;                  
								case 5:            
									s5 = s;
									//double.TryParse(s5, out d4);
									break;   									        
								case 6:            
									s6 = s;
									double.TryParse(s6, out d5);
									break;  
								case 7:   
									s7 = s;
									double.TryParse(s7, out d6);
									break;                  
								case 8:
									s8 = s;
									double.TryParse(s8, out d7);
									break;   									        
								case 9:
									s9 = s;
									double.TryParse(s9, out d8);
									break;       
								case 10:
									s10 = s;
									double.TryParse(s10, out d9);
									break;                  
								case 11:
									s10 = s;
									double.TryParse(s11, out d10);
									break;  
								case 12:
									s10 = s;
									//Print(z2);
									break;  
								case 13:
									s10 = s;
									//Print(z2);
									break;  
									
									
									
								
								default:            
									          
									break;      
							}

						
							
							
							// Resets the split counter for the next line read from the file
	//						if (splitCounter == 10)
	//							splitCounter = 0;
						}
					}
					
					if (lineCounter > 0)
					{
						//Print(s1);
						
						string iii = Instrument.MasterInstrument.Name + "#";
						
						if(s1.Contains(iii))
						{
							//Print(line);
							bool foundmatch = false;
							
							for (int i = 0; i <= entries.Count - 1; i++)
							//foreach (Entry eeee in entries)
							{
								Entry eeee = entries[i];
								
								if (eeee.Plot2 == d2)
								{
									
									foundmatch = true;
									
									string ssssss = eeee.Plot3;
									
									if (eeee.Plot3.Contains("L1")) ssssss = "L1";
									if (eeee.Plot3.Contains("L2")) ssssss = "L2";
									if (eeee.Plot3.Contains("L3")) ssssss = "L3";
									if (eeee.Plot3.Contains("L4")) ssssss = "L4";
									
									
									eeee.Plot3 = ssssss + " / " + s3;
									
									entries[i] = eeee;
								}
							}
							
							if (!foundmatch)
							entries.Add(new Entry(StartDate,s1,d2,s3,s4,s5,d6,d7,d8,d9,d10));
						}
						
						
					//Print(entries.Count);
					
//						if (!DayToValue.ContainsKey(StartDate))
//							DayToValue.Add(StartDate,new Entry(StartDate,s1,d2,s3,s4,s5,d6,d7,d8,d9,d10));
					
//						if (StartDate.Ticks > LastDate.Ticks)
//							LastDate = StartDate;
						
					}
					
					
					
					
					
					lineCounter = lineCounter + 1;
					
			
				
					
				}
				
		
//				foreach (Entry EE in entries)
//				{
//					if (pC1Enabled && EE.Plot1 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot1);
//						MinV = Math.Min(MinV,EE.Plot1);
//					}
//					if (pC2Enabled && EE.Plot2 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot2);
//						MinV = Math.Min(MinV,EE.Plot2);
//					}					
//					if (pC3Enabled && EE.Plot3 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot3);
//						MinV = Math.Min(MinV,EE.Plot3);
//					}	
//					if (pC4Enabled && EE.Plot4 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot4);
//						MinV = Math.Min(MinV,EE.Plot4);
//					}
//					if (pC5Enabled && EE.Plot5 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot5);
//						MinV = Math.Min(MinV,EE.Plot5);
//					}					
//					if (pC6Enabled && EE.Plot6 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot6);
//						MinV = Math.Min(MinV,EE.Plot6);
//					}						
//					if (pC7Enabled && EE.Plot7 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot7);
//						MinV = Math.Min(MinV,EE.Plot7);
//					}	
//					if (pC8Enabled && EE.Plot8 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot8);
//						MinV = Math.Min(MinV,EE.Plot8);
//					}
//					if (pC9Enabled && EE.Plot9 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot9);
//						MinV = Math.Min(MinV,EE.Plot9);
//					}					
//					if (pC10Enabled && EE.Plot10 != 0)
//					{
//						MaxV = Math.Max(MaxV,EE.Plot10);
//						MinV = Math.Min(MinV,EE.Plot10);
//					}
					
					
//				}
				
				
				//Print(LastDate);
				
				//return;  
			}	
		
		
		
		private double dpiX = 0;
		private	double dpiY = 0;
		
		
		private double FinalXPixel = 0;
		private	double FinalYPixel = 0;		
			
		
		private string TotalError = string.Empty;
		private string ReadMode = "";
		
		private double x1 = 0;
		private double x2 = 0;
		private double x3 = 0;
		private double x4 = 0;
				
		private double y1 = 0;
		private double y2 = 0;
		private double y3 = 0;
		private double y4 = 0;
		private double y5 = 0;
		private double y6 = 0;	
		
		private SharpDX.Direct2D1.Brush ThisBrushDX = null;
		
		//Stroke ThisStroke = new Stroke(Brushes.DarkGreen, DashStyleHelper.Solid, 2);
		
	 	Point StartPoint2	= new Point(0, 0);
		Point EndPoint2		= new Point(0, 0);
		Point TextPoint2		= new Point(0, 0);
		
		private string CellString = string.Empty;
		private SharpDX.DirectWrite.TextLayout CellLayout;
			
        private SharpDX.DirectWrite.TextFormat CellFormat;
		
		private SharpDX.RectangleF ThisRect1 = new SharpDX.RectangleF(0, 0, 0, 0);
		private SharpDX.RectangleF ThisRect2 = new SharpDX.RectangleF(0, 0, 0, 0);
		private SharpDX.RectangleF ThisRect3 = new SharpDX.RectangleF(0, 0, 0, 0);
		
		BitmapImage iconBitmapImage = new BitmapImage();
		
	struct AE
		{
			public DateTime T;
			public string	body0;
			public string	body1;
			public string 	body2;
			public double	angle;
			public string	name;
			
			public AE(DateTime iT, string ibody0, string ibody1, string ibody2, double iangle, string iName)
			{
				T = iT;
				body0 = ibody0;
				body1 = ibody1;
				body2 = ibody2;
				angle = iangle;
				name  = iName;
			}
		};
		
		private List<AE> eventList = new List<AE>();
		
		private List<string> AllLabels = new List<string>();
		
		private bool done = false;		
		
		
		private int buttonh = 27;
		
		private Brush ButtonBrush = Brushes.DarkGreen;

		private Point MP;

        private SharpDX.RectangleF B2 = new SharpDX.RectangleF(0, 0, 0, 0);

        private bool InMenu;
        private bool InMenuP;

        private bool ButtonOff = false;

		private double CurrentMousePrice = 0;

        private int space = 5;

        private SortedDictionary<double, ButtonZ> AllButtonZ = new SortedDictionary<double, ButtonZ>();

        const float fontHeight = 15f;
        private int PriceDigits = 0;
        private string PriceString = string.Empty;

		private List<string> AllTypes = new List<string>();
		
		
        private List<double> All50Levels = new List<double>();
        private List<double> All100Levels = new List<double>();

        public class ButtonZ
        {
            string iText;
            string iName;
            int iWidth;
            bool iSwitch;
            SharpDX.RectangleF iRect;
            bool iHovered;

            public string Text { get { return iText; } set { iText = value; } }
            public string Name { get { return iName; } set { iName = value; } }
            public int Width { get { return iWidth; } set { iWidth = value; } }
            public bool Switch { get { return iSwitch; } set { iSwitch = value; } }
            public SharpDX.RectangleF Rect { get { return iRect; } set { iRect = value; } }
            public bool Hovered { get { return iHovered; } set { iHovered = value; } }

        }


		private string SpreadName = string.Empty;
		private string CHLI = string.Empty;
        private int news = 22;
		
	
		private Series<int> Signals;

        private Series<double> BodyHigh;
        private Series<double> BodyLow;
        private Series<double> WickHigh;
        private Series<double> WickLow;

        private Series<int> Direction;

        private SharpDX.Vector2 StartPoint = (new Point(0, 0)).ToVector2();
        private SharpDX.Vector2 EndPoint = (new Point(0, 0)).ToVector2();

        private DateTime FirstBarTime = DateTime.MinValue;

		
		protected override void OnStateChange()
		{
            if (State == State.Configure)
		    {
               // AddDataSeries(BarsPeriodType.Tick, 1);


					
		    }
			if (State == State.SetDefaults)
			{
				Name = ThisName;
				Description					= @"";

				Calculate					= Calculate.OnPriceChange;
				IsOverlay					= true;
				DisplayInDataBox			= true;
				DrawOnPricePanel			= true;
				DrawHorizontalGridLines		= true;
				DrawVerticalGridLines		= true;
				PaintPriceMarkers			= true;
				ScaleJustification			= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				IsAutoScale = false;
				
				IsSuspendedWhileInactive	= false;
                ArePlotsConfigurable = false;
                AreLinesConfigurable = false;

                 
				numplots = 20;

								string ThisPName = "IgnorePlot";
				for (int i = 0; i < numplots; i++)
					{
						AddPlot(new Stroke(Brushes.Black, DashStyleHelper.Solid, 1),	PlotStyle.Line, ThisPName + i.ToString());
					}
					
					
            }
			else if (State == State.DataLoaded)
			{
				
				
				if (timer2 == null)
						{
							ChartControl.Dispatcher.InvokeAsync(() =>
							{
								//Print("start timer 2");
								
								timer2			= new System.Windows.Threading.DispatcherTimer { Interval = new TimeSpan(0, 0, pMinutesToUpdate, 0, 0), IsEnabled = true };
								timer2.Tick		+= OnTimer2Tick;
							});
						}
						
						
				Calculate					= Calculate.OnPriceChange;
				
				
				if (this.ChartPanel != null)
                {
					this.ChartPanel.MouseMove += new MouseEventHandler(this.OnMouseMove);
                    this.ChartPanel.MouseDown += new MouseButtonEventHandler(this.OnMouseDown);
                }

               

		        Signals = new Series<int>(this, MaximumBarsLookBack.Infinite);
                Direction = new Series<int>(this, MaximumBarsLookBack.Infinite);

                BodyHigh = new Series<double>(this, MaximumBarsLookBack.Infinite);
                BodyLow = new Series<double>(this, MaximumBarsLookBack.Infinite);
                WickHigh = new Series<double>(this, MaximumBarsLookBack.Infinite);
                WickLow = new Series<double>(this, MaximumBarsLookBack.Infinite);
				
				
//               AddButtonZ("-", "-", 1, ButtonOff);
//                AddButtonZ("+", "+", 1, ButtonOff);

				if (pShowOnOffButton != string.Empty)
				AddButtonZ(pShowOnOffButton, "pALLEnabled", 10, pALLEnabled);
				
				if (pShowLoadFileButton)
				AddButtonZ("Load File", "Load File", 10, false);
				
				
//				AddButtonZ("Transits", "pTransitsEnabled", 10, pTransitsEnabled);
				AddButtonZ("SPX", "pMainEnabled", 10, pMainEnabled);
				AddButtonZ("Trigger", "pTriggerEnabled", 10, pTriggerEnabled);
				AddButtonZ("Zero Gamma", "pZeroGammaEnabled", 10, pZeroGammaEnabled);
				AddButtonZ("SPX/SPY Combo", "pComboEnabled", 10, pComboEnabled);
//				AddButtonZ("Declinations", "pDeclinationsEnabled", 10, pDeclinationsEnabled);	
//				AddButtonZ("HDT", "pHDTEnabled", 10, pHDTEnabled);
//				AddButtonZ("+", "ButtonOff", 1, ButtonOff);				
				

				
                string FS = TickSize.ToString();
                if (FS.Contains("E-"))
                {
                    FS = FS.Substring(FS.IndexOf("E-") + 2);
                    PriceDigits = int.Parse(FS);
                }
                else PriceDigits = Math.Max(0, FS.Length - 2);
                PriceString = "n" + PriceDigits;

          		
//				if (pCurrentSetting == 1)
//						SetBarSize(pWidth1, pSpace1);
//					if (pCurrentSetting == 2)
//						SetBarSize(pWidth2, pSpace2);
//					if (pCurrentSetting == 3)
//						SetBarSize(pWidth3, pSpace3);
//					if (pCurrentSetting == 4)
//						SetBarSize(pWidth4, pSpace4);
//					if (pCurrentSetting == 5)
//						SetBarSize(pWidth5, pSpace5);		
					
					
			

			

//		        double dpiX = 0;
//				double dpiY = 0;

//				if (ChartControl != null)
//				{
//					ChartControl.Dispatcher.InvokeAsync((Action)(() =>
//					{
									
//						if (this.ChartPanel != null)
//				        if (dpiX == 0)
//				        {
//							PresentationSource source = PresentationSource.FromVisual(this.ChartPanel);
							
//							if (source != null)
//							{
//				            dpiX = 96.0 * source.CompositionTarget.TransformToDevice.M11;
//				            dpiY = 96.0 * source.CompositionTarget.TransformToDevice.M22;
							
//				             dpiX = 100.0 * source.CompositionTarget.TransformToDevice.M11;
//				            dpiY = 100.0 * source.CompositionTarget.TransformToDevice.M22;
//							}
							
//						}
						
//			           // Print(dpiX);
//						//Print(dpiY);
						
				
//					}));
//				}
				
			
		

			}
			else if ( State == State.Terminated )
			{
				
				
					if (timer2 != null)
					{
					
						timer2.IsEnabled = false;
						timer2 = null;
					}
					
					
                if (this.ChartPanel != null)
                {
                    this.ChartPanel.MouseMove -= new MouseEventHandler(this.OnMouseMove);
                    this.ChartPanel.MouseDown -= new MouseButtonEventHandler(this.OnMouseDown);
                }

			}

			
			
			
			
			
			
			if (State == State.SetDefaults)
			{
				Description = @"Expands the ChartTrader Panel.";
				//Name = "AIECT";
				Calculate = Calculate.OnPriceChange;
				IsOverlay = true;
				DisplayInDataBox = true;
				DrawOnPricePanel = true;
				DrawHorizontalGridLines = true;
				DrawVerticalGridLines = true;
				PaintPriceMarkers = true;
				ScaleJustification = NinjaTrader.Gui.Chart.ScaleJustification.Right;
				IsSuspendedWhileInactive = true;
			}
			else if (State == State.Historical)
			{
			
			}
			else if (State == State.Terminated)
			{
				
			}

		}

   
		
		private void OnTimer2Tick(object sender, EventArgs e)
		{

				
			//string timestamp2 = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff", CultureInfo.InvariantCulture);
			
			
			//Print(StartTimeBuyTimeSliced);
			
			ReadAllFiles();
			
		}
		
		
        void AddButton()
        {
            //sampleButton = new Button
            //{
            //    Content = "Sample Button",
            //    Style = System.Windows.Application.Current.TryFindResource("Button") as Style
            //};

            //sampleButton.Click += SampleButton_Click;
            //AutomationProperties.SetAutomationId(sampleButton, "SampleButton");

            ////this is the main chart trader grid where the default buttons and controls reside
            //mainGrid = chartTrader.FindName("grdMain") as Grid;

        }

		
		
		


        internal void OnMouseDown(object sender, MouseButtonEventArgs e)
        {
            this.MP = e.GetPosition(this.ChartPanel);
			
			//this.MP = e.GetPosition(this.ChartControl);

			// top chart buttons
			
            foreach (KeyValuePair<double, ButtonZ> thisbutton in AllButtonZ)
            {
                bool hoverednew = MouseIn(thisbutton.Value.Rect, 2, 2);
                string buttonn = thisbutton.Value.Name;



//               if (hoverednew && buttonn == "pHDTEnabled")
//				{
					
//				    if (pHDTEnabled)
//				    {
//				        pHDTEnabled = false;
//				    }
//				    else
//				    {
//				        pHDTEnabled = true;
//				    }
//				    thisbutton.Value.Switch = pHDTEnabled;
//				    this.ChartControl.InvalidateVisual();
					
//				}	              
// 				else if (hoverednew && buttonn == "pDeclinationsEnabled")
//				{
					
//				    if (pDeclinationsEnabled)
//				    {
//				        pDeclinationsEnabled = false;
//				    }
//				    else
//				    {
//				        pDeclinationsEnabled = true;
//				    }
//				    thisbutton.Value.Switch = pDeclinationsEnabled;
//				    this.ChartControl.InvalidateVisual();
					
//				}	  
 				if (hoverednew && buttonn == "pComboEnabled")
				{
					
				    if (pComboEnabled)
				    {
				        pComboEnabled = false;
				    }
				    else
				    {
				        pComboEnabled = true;
				    }
				    thisbutton.Value.Switch = pComboEnabled;
				    this.ChartControl.InvalidateVisual();
					
				}	  				
 				else if (hoverednew && buttonn == "pZeroGammaEnabled")
				{
					
				    if (pZeroGammaEnabled)
				    {
				        pZeroGammaEnabled = false;
				    }
				    else
				    {
				        pZeroGammaEnabled = true;
				    }
				    thisbutton.Value.Switch = pZeroGammaEnabled;
				    this.ChartControl.InvalidateVisual();
					
				}	  				
 				else if (hoverednew && buttonn == "pTriggerEnabled")
				{
					
				    if (pTriggerEnabled)
				    {
				        pTriggerEnabled = false;
				    }
				    else
				    {
				        pTriggerEnabled = true;
				    }
				    thisbutton.Value.Switch = pTriggerEnabled;
				    this.ChartControl.InvalidateVisual();
					
				}	
 				else if (hoverednew && buttonn == "pMainEnabled")
				{
					
				    if (pMainEnabled)
				    {
				        pMainEnabled = false;
				    }
				    else
				    {
				        pMainEnabled = true;
				    }
				    thisbutton.Value.Switch = pMainEnabled;
				    this.ChartControl.InvalidateVisual();
					
				}	
// 				else if (hoverednew && buttonn == "pTransitsEnabled")
//				{
					
//				    if (pTransitsEnabled)
//				    {
//				        pTransitsEnabled = false;
//				    }
//				    else
//				    {
//				        pTransitsEnabled = true;
//				    }
//				    thisbutton.Value.Switch = pTransitsEnabled;
//				    this.ChartControl.InvalidateVisual();
					
//				}					
				
				
 				else if (hoverednew && buttonn == "pALLEnabled")
				{
					
				    if (pALLEnabled)
				    {
				        pALLEnabled = false;
				    }
				    else
				    {
				        pALLEnabled = true;
				    }
					
					//PaintPriceMarkers = pALLEnabled;
					
					DrawFlags();
					
					
				    thisbutton.Value.Switch = pALLEnabled;
				    this.ChartControl.InvalidateVisual();
					this.ChartControl.InvalidateVisual();
					
					
					
				}					
 				else if (hoverednew && buttonn == "Load File")
				{
					
				    ReadAllFiles();
					
				    this.ChartControl.InvalidateVisual();
					
				}					  
				
				

            }
			
			
	



        }

	
		internal void OnMouseMove(object sender, MouseEventArgs e)
    	{
            this.MP = e.GetPosition(this.ChartPanel);

			FinalXPixel = MP.X / 100 * dpiX;
			FinalYPixel = MP.Y / 100 * dpiY;
         

            foreach (KeyValuePair<double, ButtonZ> thisbutton in AllButtonZ)
                {
                    bool hoverednew = MouseIn(thisbutton.Value.Rect, 2, 2);
                    bool hoverednow = thisbutton.Value.Hovered;

                    if (hoverednew && !hoverednow)
                    {
                        thisbutton.Value.Hovered = true;
                        this.ChartControl.InvalidateVisual();
                    }
                    if (!hoverednew && hoverednow)
                    {
                        thisbutton.Value.Hovered = false;
                        this.ChartControl.InvalidateVisual();
                    }

                }

                InMenuP = InMenu;
                InMenu = MouseIn(B2, 8, 8);
           
            if (InMenu != InMenuP)
                this.ChartControl.InvalidateVisual();

			
			this.ChartControl.InvalidateVisual();
			
			//e.Handled = true;
		}


		
	
	
		string[] returnWord(string txt)
		{
	        char[] separatingChars = {' ', ',' , '/', ':'};  
	  
	        string[] words = txt.Split(separatingChars, System.StringSplitOptions.RemoveEmptyEntries );  
	  
			return words;
		}
		
		
		
		
		private void DrawFlags()
		{
				
			int PlotN = 0;
			
			foreach (Entry eeee in entries)
			{
				
				
				string plotname = eeee.Plot3;
				double priceee = eeee.Plot2;
				
				Plots[PlotN].Name = plotname;
				
				Values[PlotN][0] = 0;
				
				if (!pALLEnabled)
					continue;
				
				
				if (plotname.Contains("L:"))
				{
					if (!pMainEnabled)
						continue;
					
					
					PlotBrushes[PlotN][0] = pMainStroke.Brush;
					
					
					
				}
				
				
				else if (plotname.Contains("Combo"))
				{
					if (!ComboEnabled)
						continue;
					
					PlotBrushes[PlotN][0] = pComboStroke.Brush;
					//ThisStroke = pComboStroke;
					
				}
				
				else if (plotname.Contains("Zero Gamma"))
				{
					if (!pZeroGammaEnabled)
						continue;
					
					PlotBrushes[PlotN][0] = ZeroGammaStroke.Brush;
					//ThisStroke = ZeroGammaStroke;
					
				}
					
				else if (plotname.Contains("Vol Trigger"))
				{
					if (!pTriggerEnabled)
						continue;
					
					PlotBrushes[PlotN][0] = pTriggerStroke.Brush;
					//ThisStroke = pTriggerStroke;
					
				}		
				else
				{
					PlotBrushes[PlotN][0] = pMainStroke.Brush;
					
				}
				
				Values[PlotN][0] = priceee;
				
				PlotN = PlotN + 1;
				
			}
					

			
		}
		
		protected override void OnBarUpdate()
		{
           	if(!done)
			{
				
				ReadAllFiles();
				
				
				done = true;
			}
			//foreach (AE a in eventList)
			//	drawEvent(a);
			
			
			
			
			DrawFlags();
							
			
			
			

        }

		
		private void ReadAllFiles()
		{
//			eventList.Clear();
//			AllTypes.Clear();
			
//			TotalError = string.Empty;
			
//			if (pFileName1 != string.Empty) ReadFile(pFileName1);
//				if (pFileName2 != string.Empty) ReadFile(pFileName2);
//				if (pFileName3 != string.Empty) ReadFile(pFileName3);
//				if (pFileName4 != string.Empty) ReadFile(pFileName4);
//				if (pFileName5 != string.Empty) ReadFile(pFileName5);
			
			ReadFile();
			
			
		}


        private void AddButtonZ(string iText, string iName, int iWidth, bool iSwitch)
        {
            ButtonZ Z = new ButtonZ();
            Z.Text = iText;
            Z.Name = iName;
            Z.Width = iWidth;
            Z.Switch = iSwitch;
            Z.Rect = new SharpDX.RectangleF(0, 0, 0, 0);
            Z.Hovered = false;

            AllButtonZ.Add(AllButtonZ.Count + 1, Z);

        }
					
	
		

        private bool MouseIn(SharpDX.RectangleF RR, int XF, int YF)
        {
            //Print(RR.Left);
            
			if (FinalXPixel != 0)
            if (FinalXPixel >= RR.Left - XF && FinalXPixel <= RR.Right + XF && FinalYPixel >= RR.Top - YF && FinalYPixel <= RR.Bottom + YF)
                return true;
           
                return false;

        }

        private double RTTS(double p)
        {
            return Instrument.MasterInstrument.RoundToTickSize(p);
        }

	
		public override void OnRenderTargetChanged()
		{
				//if (!Permission)
				//	return;			
		  // Explicitly set the Stroke RenderTarget
			
			//Print("OnRenderTargetChanged");
			
			if (RenderTarget != null)
			{
				
//				pHDTStroke.RenderTarget = RenderTarget;
//				pDeclinationsStroke.RenderTarget = RenderTarget;
				pComboStroke.RenderTarget = RenderTarget;
				pZeroGammaStroke.RenderTarget = RenderTarget;
//				pTriggerStroke.RenderTarget = RenderTarget;
				pMainStroke.RenderTarget = RenderTarget;
//				pTransitsStroke.RenderTarget = RenderTarget;				
				
			}
			
			     
				
			
		}
	
		protected override void OnRender(ChartControl chartControl, ChartScale chartScale)
		{		
			if (CurrentBars[0] < 0)
				return;


            // Instantiate a ChartControlProperties object to hold a reference to chartControl.Properties
            ChartControlProperties myProperties = chartControl.Properties;


			SharpDX.Direct2D1.AntialiasMode oldAntialiasMode	= RenderTarget.AntialiasMode;
            //RenderTarget.AntialiasMode							= SharpDX.Direct2D1.AntialiasMode.Aliased;

       
 

            // Set the AllowSelectionDragging property to false
            myProperties.AllowSelectionDragging = false;
            
			//base.OnRender(chartControl, chartScale);

            System.Windows.Media.Brush textBrush2 = myProperties.ChartText;
            SharpDX.Direct2D1.Brush textBrushDX2 = textBrush2.ToDxBrush(RenderTarget);

            System.Windows.Media.Brush textBrush = Brushes.RoyalBlue;
            SharpDX.Direct2D1.Brush textBrushDX = textBrush.ToDxBrush(RenderTarget);

			
            System.Windows.Media.Brush buttonBrush = ChartControl.Properties.AxisPen.Brush;
            SharpDX.Direct2D1.Brush buttonBrushDX = buttonBrush.ToDxBrush(RenderTarget);

            System.Windows.Media.Brush buttonHBrush = ChartControl.Properties.AxisPen.Brush;
            SharpDX.Direct2D1.Brush buttonHBrushDX = buttonHBrush.ToDxBrush(RenderTarget);

            System.Windows.Media.Brush buttonFHBrush = ChartControl.Properties.AxisPen.Brush;
            SharpDX.Direct2D1.Brush buttonFHBrushDX = buttonFHBrush.ToDxBrush(RenderTarget);

            System.Windows.Media.Brush buttonFOFFBrush = ChartControl.Properties.ChartBackground;
            SharpDX.Direct2D1.Brush buttonFOFFBrushDX = buttonFOFFBrush.ToDxBrush(RenderTarget);

            System.Windows.Media.Brush buttonFONBrush = Brushes.Green;
            SharpDX.Direct2D1.Brush buttonFONBrushDX = pMainButtonOnColor.ToDxBrush(RenderTarget);


			SharpDX.Direct2D1.Brush ChartBackgroundFadeBrushDX = ChartControl.Properties.ChartBackground.ToDxBrush(RenderTarget);
			ChartBackgroundFadeBrushDX.Opacity = 0.5f;
			
            //SharpDX.Direct2D1.StrokeStyle 
            //buttonBrushDX = new SharpDX.Direct2D1.Brush(ChartControl.Properties.AxisPen.BrushDX);
            // buttonHBrushDX = ChartControl.Properties.AxisPen.BrushDX;

  

            //ChartTraderProperties

            //NinjaTrader.Gui.Chart.charttraderp

            //NinjaTrader.Gui.Chart.ChartTraderProperties;


            //     ChartTraderProperties myprop = chartTrader.FindFirst("ChartTraderProperties") as NinjaTrader.Gui.Chart.ChartTraderProperties;


            //  ChartControlProperties myProperties = chartControl.Properties;


            

           // if (ChartControl.Properties.ChartBackground == blackBrush)
            {
               // Print("asf");

                //buttonHBrushDX.Opacity = 0.7f;
                //buttonFHBrushDX.Opacity = 0.4f;
                //buttonFONBrushDX.Opacity = 0.9f;

            }
           // else
            {
                buttonHBrushDX.Opacity = 0.5f;
                buttonFHBrushDX.Opacity = 0.0f;
                buttonFONBrushDX.Opacity = 0.2f;
            }

            

            

           
            //Print(CY);
           
            //SizeF szvv = graphics.MeasureString("B", ChartControl.Font);


            //bsize2 = (int)szvv.Height + 2;
           

	
          

            //SharpDX.RectangleF rectangleF = new SharpDX.RectangleF( (float) MP.X-5F, 0F, 10F, 10000F );
            //SharpDX.Direct2D1.Brush textBrushDX2 = textBrushDX.

            int FB = ChartBars.FromIndex;
            int LB = ChartBars.ToIndex;
            int BB = 0;
            int xt = 0;
            int yt = 0;
			
			x1 = 0;
			x2 = 0;
			x3 = 0;
			x4 = 0;
				
			y1 = 0;
			y2 = 0;
			y3 = 0;
			y4 = 0;
			y5 = 0;
			y6 = 0;	
			
			
            //if (Calculate.OnBarClose)
            LB = Math.Min(CurrentBars[0], LB);
            BB = CurrentBars[0] - LB;

			
			// resolve issue with other windows 10 font scaling automatically
			
//				if (ChartControl != null)
//				{
//					ChartControl.Dispatcher.InvokeAsync((Action)(() =>
//					{
									
//						if (this.ChartPanel != null)
				        if (dpiX == 0)
				        {
							PresentationSource source = PresentationSource.FromVisual(this.ChartPanel);
							
							if (source != null)
							{
				            dpiX = 96.0 * source.CompositionTarget.TransformToDevice.M11;
				            dpiY = 96.0 * source.CompositionTarget.TransformToDevice.M22;
							
				             dpiX = 100.0 * source.CompositionTarget.TransformToDevice.M11;
				            dpiY = 100.0 * source.CompositionTarget.TransformToDevice.M22;
							}
							
						}
						
				
//					}));
//				}
				
				
			//Print(dpiX);
			
			FinalXPixel = MP.X / 100 * dpiX;
			FinalYPixel = MP.Y / 100 * dpiY;
			
			//Print(FinalXPixel);
			
           CurrentMousePrice = chartScale.MaxValue - chartScale.MaxMinusMin * (FinalYPixel / chartScale.Height);

			CurrentMousePrice = RTTS(CurrentMousePrice);

            

            double mousebar = (ChartControl.GetXByBarIndex(ChartBars, ChartBars.ToIndex) - ChartControl.GetXByBarIndex(ChartBars, ChartBars.FromIndex)) / Math.Max(1,(ChartBars.ToIndex - ChartBars.FromIndex)); //chartControl.GetBarPaintWidth(ChartBars);

            double mousebar2 = ChartBars.FromIndex + (FinalXPixel - ChartControl.GetXByBarIndex(ChartBars, ChartBars.FromIndex)) / mousebar;

            int mousebar3 = (int) Math.Round(mousebar2, 0);

            SharpDX.DirectWrite.TextFormat textFormat = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory, "Arial", SharpDX.DirectWrite.FontWeight.Normal,
            SharpDX.DirectWrite.FontStyle.Normal, SharpDX.DirectWrite.FontStretch.Normal, 12.0F);

			//textFormat = myProperties.LabelFont.ToDirectWriteTextFormat();
		
            //{ TextAlignment = SharpDX.DirectWrite.TextAlignment.Leading, WordWrapping = WordWrapping.NoWrap };

            String text = "Mouse: (" + this.MP.X.ToString() + " , " + this.MP.Y.ToString() + " )" + Environment.NewLine;

            text = CurrentMousePrice.ToString(PriceString) + " " + mousebar3.ToString() + " " + CurrentBar.ToString();
			
			
            SharpDX.RectangleF rectangleF = new SharpDX.RectangleF(10F, 20F, 200F, 50F);


            double yt22 = chartScale.GetYByValue(chartScale.MinValue) - 17;
            SharpDX.RectangleF BottomRect = new SharpDX.RectangleF(140, (float)yt22, 2000F, 21);

            

            SharpDX.DirectWrite.TextFormat BottomText = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory,
                "Arial",
                SharpDX.DirectWrite.FontWeight.Normal,
                SharpDX.DirectWrite.FontStyle.Normal,
                SharpDX.DirectWrite.FontStretch.Normal,
                11.0F);

            BottomText.TextAlignment = SharpDX.DirectWrite.TextAlignment.Leading;
            BottomText.ParagraphAlignment = SharpDX.DirectWrite.ParagraphAlignment.Center;
            BottomText.WordWrapping = SharpDX.DirectWrite.WordWrapping.NoWrap;

            BottomText = ChartControl.Properties.LabelFont.ToDirectWriteTextFormat();

			
			oldAntialiasMode	= RenderTarget.AntialiasMode;
			RenderTarget.AntialiasMode							= SharpDX.Direct2D1.AntialiasMode.Aliased;
				
			text = TotalError;
			
			if (text != string.Empty)
				RenderTarget.DrawText(text, BottomText, BottomRect, textBrushDX2);

			RenderTarget.AntialiasMode = oldAntialiasMode;
			
			
			
			
			
			

            SharpDX.DirectWrite.TextFormat PrintText = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory,
                "Arial",
                SharpDX.DirectWrite.FontWeight.Normal,
                SharpDX.DirectWrite.FontStyle.Normal,
                SharpDX.DirectWrite.FontStretch.Normal,
                11.0F);

            PrintText.TextAlignment = SharpDX.DirectWrite.TextAlignment.Center;
            PrintText.ParagraphAlignment = SharpDX.DirectWrite.ParagraphAlignment.Center;
            PrintText.WordWrapping = SharpDX.DirectWrite.WordWrapping.NoWrap;

            string tttgdf = string.Empty;


            TextLayout textLayout2 = new TextLayout(Core.Globals.DirectWriteFactory, tttgdf, PrintText, 10000, 10000);

            // Print(textLayout1.Metrics.Width);
            float OrderButtonSize = 15;

            float FinalH2 = textLayout2.Metrics.Height + 5;

           
			
			// draw lines
			

			
			SharpDX.Direct2D1.Brush LineTextBrushDX = pMainTextColor.ToDxBrush(RenderTarget);
			
      

			
			
			CellString = string.Empty;
			CellFormat = pTextFont2.ToDirectWriteTextFormat();
			CellLayout = new TextLayout(Core.Globals.DirectWriteFactory, CellString, CellFormat, 10000, 10000);
			
//             CellFormat = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory, "Arial", SharpDX.DirectWrite.FontWeight.Normal,
//                    SharpDX.DirectWrite.FontStyle.Normal, SharpDX.DirectWrite.FontStretch.Normal, 11.0F);

					CellFormat			= pTextFont2.ToDirectWriteTextFormat();	
                    //CellText = myProperties.LabelFont.ToDirectWriteTextFormat();

                    CellFormat.TextAlignment = SharpDX.DirectWrite.TextAlignment.Center;
                    CellFormat.ParagraphAlignment = SharpDX.DirectWrite.ParagraphAlignment.Center;
                    CellFormat.WordWrapping = SharpDX.DirectWrite.WordWrapping.NoWrap;
			
			bool DrawTextOK = true;
			
			
			float AddY = 0;
			
			AllLabels.Clear();
			
			
			
			if (ErrorText == string.Empty)
			if (pALLEnabled)
			{
				
				
				// text
				
				
				
				
				
				
				
					if (pPrintEnabled2)
					foreach (Entry eeee in entries)
				{
					
					
					string plotname = eeee.Plot3;
					//Print(eeee.Plot2);
					CellString = plotname;
					
					
	//				y = chartScale.GetYByValue(eeee.Plot2);
	//				x = 0;
	//				x2 = ChartPanel.X + ChartPanel.W;
					
	//				startPoint	= new Point(x, y);
	//				endPoint		= new Point(x2, y);

	//				SharpDX.Direct2D1.AntialiasMode oldAntialiasMode	= RenderTarget.AntialiasMode;		
	//				RenderTarget.AntialiasMode							= SharpDX.Direct2D1.AntialiasMode.PerPrimitive;

					
					
					ThisStroke = pMainStroke;
					
					
					if (plotname.Contains("L:"))
					{
						if (!pMainEnabled)
							continue;
						
						ThisStroke = pMainStroke;
						
					}
					
					
					if (plotname.Contains("Combo"))
					{
						if (!ComboEnabled)
							continue;
						
						ThisStroke = pComboStroke;
						
					}
					
					if (plotname.Contains("Zero Gamma"))
					{
						if (!pZeroGammaEnabled)
							continue;
						
						ThisStroke = ZeroGammaStroke;
						
					}
						
					if (plotname.Contains("Vol Trigger"))
					{
						if (!pTriggerEnabled)
							continue;
						
						ThisStroke = pTriggerStroke;
						
					}		
					
					//FinalBrushDX		= ThisStroke.Brush.ToDxBrush(RenderTarget);	
					LineTextBrushDX = ThisStroke.Brush.ToDxBrush(RenderTarget);	
		
			
	     
						CellLayout = new TextLayout(Core.Globals.DirectWriteFactory, CellString, CellFormat, 10000, 10000);
						
						float twidth = CellLayout.Metrics.Width;
						float theight = CellLayout.Metrics.Height;
					
					
	//					x1 = chartControl.GetXByTime(a.T);
	//					x2 = x1;
						
	//					y1 = 0;
	//					y2 = 10000;
						
						
											
						
					
						
						
						
						float spacetop = 8;
						float spacetop2 = 4; // vertical space between boxes
						float yboxexpand = 3;
						
						
						ThisRect1 = new SharpDX.RectangleF((float)x1 - twidth / 2, spacetop+yboxexpand+AddY, (float)twidth, (float)theight);
					
						x1 = ChartPanel.X + ChartPanel.W - twidth - 5;
						y1 = 	chartScale.GetYByValue(eeee.Plot2) - theight - 3 - ThisStroke.Width/2;
					
					
						ThisRect1 = new SharpDX.RectangleF((float)x1, (float)y1, (float)twidth, (float)theight);
							
						ThisRect2 = ExpandRect(ThisRect1,5,30,yboxexpand,yboxexpand);
						ThisRect3 = ExpandRect(ThisRect2,2,2);
						
						ThisBrushDX = ThisStroke.Brush.ToDxBrush(RenderTarget);
						ThisBrushDX.Opacity = pHiddenOrdersOpacity/100f;
						
						
						//y1 = ThisRect2.Bottom;
						
							StartPoint2 = new Point(x1,y1);
							EndPoint2 = new Point(x2,y2);
								
							//RenderTarget.DrawLine(StartPoint2.ToVector2(), EndPoint2.ToVector2(), ThisStroke.BrushDX, ThisStroke.Width, ThisStroke.StrokeStyle);
						
						
						
						double leftm = x1 - pMousePlay;
						double rightm = x1 + pMousePlay;
						
						DrawTextOK = FinalXPixel >= leftm && FinalXPixel <= rightm;
						DrawTextOK = true;
					
						if (!AllLabels.Contains(CellString))
						if (pPrintEnabled2 && DrawTextOK)
						{
							
							//RenderTarget.FillRectangle(ThisRect3, ChartBackgroundFadeBrushDX);
							//RenderTarget.FillRectangle(ThisRect2, buttonFOFFBrushDX);
							RenderTarget.FillRectangle(ThisRect2, ThisBrushDX);
							//RenderTarget.DrawRectangle(ExpandRect(ThisRect2,-1,-1,-1,0), ThisBrushDX);
							RenderTarget.DrawText(CellString, CellFormat, ThisRect1, LineTextBrushDX);
							
							AddY = AddY + ThisRect2.Height + spacetop2;
							AllLabels.Add(CellString);
						}
						
						
			
		
					
					//RenderTarget.DrawLine(startPoint.ToVector2(), endPoint.ToVector2(),  FinalBrushDX, ThisStroke.Width, ThisStroke.StrokeStyle);
					//RenderTarget.AntialiasMode = oldAntialiasMode;
					
					
					
				}
						

				
				
			
					
				
						
				DrawFuturePlot(chartControl, chartScale, 0, 0);
				

				
				
			
			
				
				
			}
			
			
			
				LineTextBrushDX.Dispose();
				
				
				// end draw lines

 float CY = (float)chartControl.CanvasRight - 2f;
			
                    SharpDX.DirectWrite.TextFormat ButtonText2 = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory, "Arial", SharpDX.DirectWrite.FontWeight.Normal,
                    SharpDX.DirectWrite.FontStyle.Normal, SharpDX.DirectWrite.FontStretch.Normal, 11.0F);

                    ButtonText2 = myProperties.LabelFont.ToDirectWriteTextFormat();
                   // Print(textLayout1.Metrics.Width);
TextLayout textLayout222 = new TextLayout(Core.Globals.DirectWriteFactory, "LLL", ButtonText2, 10000, 10000);

                    float FinalH23 = textLayout222.Metrics.Height;
			
            B2 = new SharpDX.RectangleF(0, ChartPanel.H - FinalH23 - space - 4, 10000, pButtonSize + 2);

textLayout222.Dispose();

            // if (MouseIn(B2, 2, 2))


            if (pButtonsEnabled && InMenu)
                foreach (KeyValuePair<double, ButtonZ> thisbutton in AllButtonZ)
                //foreach (string xxx in AllButtons)
                {

				
					
					
                    string xxx = thisbutton.Value.Text;

					
						if (!AllTypes.Contains(xxx) && xxx != pShowOnOffButton && xxx != "Load File")
							continue;
						
						
                    string sd = xxx;



                    // szvv = graphics.MeasureString(sd, ChartControl.Font);

                    // int widdd = (int)szvv.Width + 8;


                    float widdd = 40;
                    widdd = Math.Max(pButtonSize, widdd);

                    if (thisbutton.Value.Width == 1)
                        widdd = pButtonSize;
                    else
                        widdd = thisbutton.Value.Width;


                    



                    SharpDX.DirectWrite.TextFormat ButtonText = new SharpDX.DirectWrite.TextFormat(Core.Globals.DirectWriteFactory, "Arial", SharpDX.DirectWrite.FontWeight.Normal,
                    SharpDX.DirectWrite.FontStyle.Normal, SharpDX.DirectWrite.FontStretch.Normal, 11.0F);

                    ButtonText = myProperties.LabelFont.ToDirectWriteTextFormat();

                    ButtonText.TextAlignment = SharpDX.DirectWrite.TextAlignment.Center;
                    ButtonText.ParagraphAlignment = SharpDX.DirectWrite.ParagraphAlignment.Center;
                    ButtonText.WordWrapping = SharpDX.DirectWrite.WordWrapping.NoWrap;

                    TextLayout textLayout1 = new TextLayout(Core.Globals.DirectWriteFactory, thisbutton.Value.Text, ButtonText, 10000, 10000);

                   // Print(textLayout1.Metrics.Width);


                    float FinalH = textLayout1.Metrics.Height;

                    FinalH = Math.Max(pButtonSize, FinalH);

                    float FinalW = Math.Max(FinalH,textLayout1.Metrics.Width);

                    if (thisbutton.Value.Width == 1)
                        FinalW = FinalH;
                    else
                        FinalW = textLayout1.Metrics.Width + 8;


                    CY = CY - FinalW;
                    thisbutton.Value.Rect = new SharpDX.RectangleF(CY, ChartPanel.H - FinalH - space + 3, FinalW, FinalH);
                    CY = CY - space;

                    //CY = CY - widdd - space;
                   // thisbutton.Value.Rect = new SharpDX.RectangleF(CY, space, widdd, pButtonSize);
                   
                    
					

                    RenderTarget.FillRectangle(thisbutton.Value.Rect, buttonFOFFBrushDX);
					
					

					
										
					
                    if (thisbutton.Value.Switch)
					{
						
						
						string thisname333 = thisbutton.Value.Text;
						
//							if (thisname333 == "HDT")
//						{
//							if (!pHDTEnabled)
//								continue;
							
//							//thisname = "HDT";
//							ThisStroke = pHDTStroke;
//							//CellString = a.body0[0] + dash + thisname + dash + a.body1 + slash + a.body2;
//						}
						
//						if (thisname333 == "Declinations")
//						{
//							if (!pDeclinationsEnabled)
//								continue;						
							
//							//thisname = "DEC";
//							ThisStroke = pDeclinationsStroke;
//							//CellString = thisname + dash + a.body0 + dash + a.body1[0];
//						}
						if (thisname333 == "Combo")
						{
							if (!pComboEnabled)
								continue;
							
							//thisname = "LAT";
							ThisStroke = pComboStroke;
							//CellString = thisname + dash + a.body0 + dash + a.body1[0];
						}										
						if (thisname333 == "Zero Gamma")
						{
							if (!pZeroGammaEnabled)
								continue;
							
						
							ThisStroke = pZeroGammaStroke;
							
						}						
						if (thisname333 == "Trigger")
						{
							if (!pTriggerEnabled)
								continue;
							
						
							ThisStroke = pTriggerStroke;
							
						}		
						if (thisname333 == "SPX")
						{
							if (!pMainEnabled)
								continue;
							
						
							ThisStroke = pMainStroke;
							
						}	
//						if (thisname333 == "Transits")
//						{
//							if (!pTransitsEnabled)
//								continue;
							
						
//							ThisStroke = pTransitsStroke;
							
//						}	
						
						
						
						ThisBrushDX = ThisStroke.Brush.ToDxBrush(RenderTarget);
						ThisBrushDX.Opacity = 0.2f;
						
						if (thisname333 == pShowOnOffButton)
							RenderTarget.FillRectangle(thisbutton.Value.Rect, buttonFONBrushDX); 
						else
                        RenderTarget.FillRectangle(thisbutton.Value.Rect, ThisBrushDX); //buttonFONBrushDX
						
					}

                    if (MouseIn(thisbutton.Value.Rect, 2, 2))
                    {
                        if (!thisbutton.Value.Switch)
                            RenderTarget.FillRectangle(thisbutton.Value.Rect, buttonFOFFBrushDX);

                        RenderTarget.DrawRectangle(thisbutton.Value.Rect, buttonHBrushDX, 3);

                    }

                    RenderTarget.DrawRectangle(thisbutton.Value.Rect, buttonBrushDX, 1);
                    RenderTarget.DrawText(thisbutton.Value.Text, ButtonText, thisbutton.Value.Rect, buttonBrushDX);
                }




            textBrushDX2.Dispose();
			textBrushDX.Dispose();
			
				
			buttonBrushDX.Dispose();
            buttonHBrushDX.Dispose();
			buttonFHBrushDX.Dispose();
            buttonFOFFBrushDX.Dispose();
			buttonFONBrushDX.Dispose();	
				
			ChartBackgroundFadeBrushDX.Dispose();	
			
		}

		
		
		
        private void DrawFuturePlot(ChartControl chartControl, ChartScale chartScale, int dataOffset, int plotNum)
        {
			//Print("DrawFuturePlot");
			
			Point startPoint	= new Point(ChartPanel.X, ChartPanel.Y);
			Point endPoint		= new Point(ChartPanel.X + ChartPanel.W, ChartPanel.Y + ChartPanel.H);
			
			//return;
			
			
			//Series<double> data = alligatorValue1;
			//int dataOffset = alligatorOffset1;
			//int plotNum = 0;
			
			//Plot	plot				= Plots[plotNum];
			SharpDX.Direct2D1.Brush			FinalBrushDX		= pMainStroke.Brush.ToDxBrush(RenderTarget);	
			
			int num = 0;
            int x = -1;
			            int x2 = -1;
			int y = 0;
            double num3 = -1.0;
           // GraphicsPath path = new GraphicsPath();
			
			
			
			bool ShowBarsRequired = false; //base.ChartControl.ShowBarsRequired 
			
			
			//DateTime ThisS2 = ChartBars.GetTimeByBarIdx(chartControl, ChartBars.ToIndex);
			//DateTime NewT2 = new DateTime(ThisS2.Year, ThisS2.Month, ThisS2.Day, 0, 0, 0);
			//Print(NewT2);
			//Print(ChartBars.ToIndex);
			
			//Print("VB: " + ChartBars.ToIndex);
			//Print("CB: " + RightEdgeBar);
			
			//Print("DrawFuturePlot2");
			//Print(entries.Count);
			foreach (Entry eeee in entries)
			{
				
				
				string plotname = eeee.Plot3;
				//Print(eeee.Plot2);
				
				y = chartScale.GetYByValue(eeee.Plot2);
				x = 0;
				x2 = ChartPanel.X + ChartPanel.W;
				
				startPoint	= new Point(x, y);
				endPoint		= new Point(x2, y);

				SharpDX.Direct2D1.AntialiasMode oldAntialiasMode	= RenderTarget.AntialiasMode;		
				RenderTarget.AntialiasMode							= SharpDX.Direct2D1.AntialiasMode.PerPrimitive;

				
				
				ThisStroke = pMainStroke;
				
				
				if (plotname.Contains("L:"))
				{
					if (!pMainEnabled)
						continue;
					
					ThisStroke = pMainStroke;
					
				}
				
				
				if (plotname.Contains("Combo"))
				{
					if (!ComboEnabled)
						continue;
					
					ThisStroke = pComboStroke;
					
				}
				
				if (plotname.Contains("Zero Gamma"))
				{
					if (!pZeroGammaEnabled)
						continue;
					
					ThisStroke = ZeroGammaStroke;
					
				}
					
				if (plotname.Contains("Vol Trigger"))
				{
					if (!pTriggerEnabled)
						continue;
					
					ThisStroke = pTriggerStroke;
					
				}		
				
				FinalBrushDX		= ThisStroke.Brush.ToDxBrush(RenderTarget);	
				
	
		
     
		
		
	
				
				RenderTarget.DrawLine(startPoint.ToVector2(), endPoint.ToVector2(),  FinalBrushDX, ThisStroke.Width, ThisStroke.StrokeStyle);
				RenderTarget.AntialiasMode = oldAntialiasMode;
				
				
				
			}
					

							
			
			
			
			
        }
		
		
		

 		private SharpDX.RectangleF ExpandRect (SharpDX.RectangleF RR, float left, float right, float top, float bottom)
		{
			
			SharpDX.RectangleF FF = new SharpDX.RectangleF(RR.X-left, RR.Y-top, RR.Width+left+right, RR.Height+top+bottom);
				
			return FF;
			
		}
		
		private SharpDX.RectangleF ExpandRect (SharpDX.RectangleF RR, float xe, float ye)
		{
			
			SharpDX.RectangleF FF = new SharpDX.RectangleF(RR.X-xe, RR.Y-ye, RR.Width+xe*2, RR.Height+ye*2);
				
			return FF;
			
		}  
   
		public override string DisplayName
		{
			get
			{
					
				return ThisName;
				
				if (State == State.SetDefaults)
						return ThisName;
					else
						return "";
					
			}
		
		}	
        // INPUTS

        



        private Brush areaBrush = Brushes.DodgerBlue;
        private Brush textBrush = Brushes.Blue;
        private Brush smallAreaBrush = Brushes.Red;
        private int areaOpacity = 50;
       // const float fontHeight = 30f;



		
        private bool pButtonsEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), Name = "Enabled", GroupName = "Chart Buttons", Order = 1)]
        public bool ButtonsEnabled
        {
            get { return pButtonsEnabled; }
            set { pButtonsEnabled = value; }
        }


        private int pButtonSize = 18;
        [Range(1, int.MaxValue)]
        [Display(ResourceType = typeof(Custom.Resource), Name = "Size (Pixels)", GroupName = "Chart Buttons", Order = 5)]
        public int ButtonSize
        {
            get { return pButtonSize; }
            set { pButtonSize = value; }
        }
		
       private bool pShowLoadFileButton = false;
        [Display(ResourceType = typeof(Custom.Resource), Name = "Load File Enabled", GroupName = "Chart Buttons", Order = 11)]
        public bool ShowLoadFileButton
        {
            get { return pShowLoadFileButton; }
            set { pShowLoadFileButton = value; }
        }		
		
//       private bool pShowOnOffButton = true;
//        [Display(ResourceType = typeof(Custom.Resource), Name = "Enabled", GroupName = "Chart Buttons", Order = 11)]
//        public bool ShowOnOffButton
//        {
//            get { return pShowOnOffButton; }
//            set { pShowOnOffButton = value; }
//        }				
		
		private string pShowOnOffButton = "SG";
		[Description("")]
		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Chart Buttons", Name = "On Off Button", Order = 20)]
		public string ShowOnOffButton
		{
			get { return pShowOnOffButton; }
			set { pShowOnOffButton = value; }
		}
				

		private Brush pMainButtonOnColor = Brushes.Silver;
//		[XmlIgnore]
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Chart Buttons", Name = "On Color", Order = 3)]
//		public Brush MainButtonOnColor
//		{
//			get { return pMainButtonOnColor; } set { pMainButtonOnColor = value; }
//		}
//		[Browsable(false)]
//		public string MainButtonOnColorS
//		{
//			get { return Serialize.BrushToString(pMainButtonOnColor); } set { pMainButtonOnColor = Serialize.StringToBrush(value); }
//		}	

        private int pMousePlay = 8;
//        [Range(1, int.MaxValue), NinjaScriptProperty]
//        [Display(ResourceType = typeof(Custom.Resource), Name = "Mouse Trigger (Pixels)", GroupName = "Labels", Order = 5)]
//        public int MousePlay
//        {
//            get { return pMousePlay; }
//            set { pMousePlay = value; }
//        }
		
		private bool pPrintEnabled2 = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Labels", Name = "Enabled", Order = 0)]
		[RefreshProperties(RefreshProperties.All)] // Update UI when value is changed
        public bool PrintEnabled2
        {
            get { return pPrintEnabled2; }
            set { pPrintEnabled2 = value; }
        }	
		
		
		private SimpleFont pTextFont2 = new SimpleFont("Arial", 11);
		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Labels", Name = "Font", Description = "", Order = 2)]
		public SimpleFont TextFont2
        {
            get { return pTextFont2; }
            set { pTextFont2= value; }
        }	
		
		private int pHiddenOrdersOpacity = 20;
        [Range(0, 100)]
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Labels", Name = "Box Opacity (%)", Order = 61)]
        public int HiddenOrdersOpacity
        {
            get { return pHiddenOrdersOpacity; }
            set { pHiddenOrdersOpacity = value; }
        }	
						

		
		private Brush pMainTextColor = Brushes.WhiteSmoke;
//		[XmlIgnore]
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Labels", Name = "Text Color", Order = 3)]
//		public Brush MainTextColor
//		{
//			get { return pMainTextColor; } set { pMainTextColor = value; }
//		}
//		[Browsable(false)]
//		public string MainTextColorS
//		{
//			get { return Serialize.BrushToString(pMainTextColor); } set { pMainTextColor = Serialize.StringToBrush(value); }
//		}	
		
		
		
		
//        private bool pHDTEnabled = true;
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "HDT", Name = "Enabled", Order = 1)]
//        public bool HDTEnabled
//        {
//            get { return pHDTEnabled; }
//            set { pHDTEnabled = value; }
//        }
		
//        private Stroke pHDTStroke = new Stroke(Brushes.DarkViolet, DashStyleHelper.Solid, 2);
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "HDT", Name = "Display", Order = 2)]
//        public Stroke HDTStroke
//        {
//            get { return pHDTStroke; }
//            set { pHDTStroke = value; }
//        }	
		
//        private bool pDeclinationsEnabled = true;
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Declinations", Name = "Enabled", Order = 1)]
//        public bool DeclinationsEnabled
//        {
//            get { return pDeclinationsEnabled; }
//            set { pDeclinationsEnabled = value; }
//        }
		
//        private Stroke pDeclinationsStroke = new Stroke(Brushes.DarkTurquoise, DashStyleHelper.Solid, 2);
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Declinations", Name = "Display", Order = 2)]
//        public Stroke DeclinationsStroke
//        {
//            get { return pDeclinationsStroke; }
//            set { pDeclinationsStroke = value; }
//        }		
		
        private bool pComboEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "SPX/SPY Combo", Name = "Enabled", Order = 1)]
        public bool ComboEnabled
        {
            get { return pComboEnabled; }
            set { pComboEnabled = value; }
        }
		
        private Stroke pComboStroke = new Stroke(Brushes.Gold, DashStyleHelper.Solid, 4);
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "SPX/SPY Combo", Name = "Display", Order = 2)]
        public Stroke ComboStroke
        {
            get { return pComboStroke; }
            set { pComboStroke = value; }
        }	
		
        private bool pZeroGammaEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Zero Gamma", Name = "Enabled", Order = 1)]
        public bool ZeroGammaEnabled
        {
            get { return pZeroGammaEnabled; }
            set { pZeroGammaEnabled = value; }
        }
		
        private Stroke pZeroGammaStroke = new Stroke(Brushes.Gold, DashStyleHelper.Solid, 4);
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Zero Gamma", Name = "Display", Order = 2)]
        public Stroke ZeroGammaStroke
        {
            get { return pZeroGammaStroke; }
            set { pZeroGammaStroke = value; }
        }	
		
        private bool pTriggerEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Trigger", Name = "Enabled", Order = 1)]
        public bool TriggerEnabled
        {
            get { return pTriggerEnabled; }
            set { pTriggerEnabled = value; }
        }
		
        private Stroke pTriggerStroke = new Stroke(Brushes.Gold, DashStyleHelper.Solid, 4);
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Trigger", Name = "Display", Order = 2)]
        public Stroke TriggerStroke
        {
            get { return pTriggerStroke; }
            set { pTriggerStroke = value; }
        }	
		
		
     
		
		
		
        private bool pMainEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "SPX", Name = "Enabled", Order = 1)]
        public bool MainEnabled
        {
            get { return pMainEnabled; }
            set { pMainEnabled = value; }
        }
		
        private Stroke pMainStroke = new Stroke(Brushes.Gold, DashStyleHelper.Solid, 4);
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "SPX", Name = "Display", Order = 2)]
        public Stroke MainStroke
        {
            get { return pMainStroke; }
            set { pMainStroke = value; }
        }			
				
  
//		private bool pTransitsEnabled = true;
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Transit To Transit", Name = "Enabled", Order = 1)]
//        public bool TransitsEnabled
//        {
//            get { return pTransitsEnabled; }
//            set { pTransitsEnabled = value; }
//        }
		
//        private Stroke pTransitsStroke = new Stroke(Brushes.White, DashStyleHelper.Solid, 2);
//        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Transit To Transit", Name = "Display", Order = 2)]
//        public Stroke TransitsStroke
//        {
//            get { return pTransitsStroke; }
//            set { pTransitsStroke = value; }
//        }			
		
		
		
		
        private bool pALLEnabled = true;
        [Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "Enabled", Order = -11)]
        public bool ALLEnabled
        {
            get { return pALLEnabled; }
            set { pALLEnabled = value; }
        }
		
		
		
		
//		private string pFolderLocation = @"C:\";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Location", Description = "", Order = 10)]
//        public string FolderLocation
//        {
//            get { return pFolderLocation; }
//            set { pFolderLocation = value; }
//        }		
				
//		private string pFileName1 = @"HDT";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Name 1", Description = "", Order = 20)]
//        public string FileName1
//        {
//            get { return pFileName1; }
//            set { pFileName1 = value; }
//        }		
		
//		private string pFileName2 = @"";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Name 2", Description = "", Order = 21)]
//        public string FileName2
//        {
//            get { return pFileName2; }
//            set { pFileName2 = value; }
//        }	
		
//		private string pFileName3 = @"";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Name 3", Description = "", Order = 22)]
//        public string FileName3
//        {
//            get { return pFileName3; }
//            set { pFileName3 = value; }
//        }		
		
//		private string pFileName4 = @"";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Name 4", Description = "", Order = 23)]
//        public string FileName4
//        {
//            get { return pFileName4; }
//            set { pFileName4 = value; }
//        }	
		
//		private string pFileName5 = @"";	
//		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Name 5", Description = "", Order = 24)]
//        public string FileName5
//        {
//            get { return pFileName5; }
//            set { pFileName5 = value; }
//        }
		
		
			private string pTimeSlicedLeftoverAction = "Web";
		[Description("")]
		[Display(ResourceType = typeof(Custom.Resource), GroupName = "Parameters", Name = "File Location", Order = 0)]
		[RefreshProperties(RefreshProperties.All)]
		[TypeConverter(typeof(ThisTimeSlicedLeftoverAction))]
		public string TimeSlicedLeftoverAction
		{
			get { return pTimeSlicedLeftoverAction; }
			set { pTimeSlicedLeftoverAction = value; }
		}
		
		
		
		internal class ThisTimeSlicedLeftoverAction : StringConverter
		{
			public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
			{
			//true means show a combobox
				return true;
			}
			
			public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
			{
			//true will limit to list. false will show the list, but allow free-form entry
				return true;
			}
		
			public override System.ComponentModel.TypeConverter.StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
			{
				return new StandardValuesCollection( new String[] {"Local", "Web"} );
			}
		}			
		
		
		
		
		private string pWebLocation =  "http://www.joelwyse.com/anthony/";	
		[Display(ResourceType = typeof(Custom.Resource), Name = "File URL", GroupName = "Parameters", Order = 10)]
        public string WebLocation
        {
            get { return pWebLocation; }
            set { pWebLocation = value; }
        }		

		
		
		private string pThisLocation = @"C:\";
		[Display(ResourceType = typeof(Custom.Resource), Name = "File Folder", GroupName = "Parameters", Order = 20)]
        public string ThisLocation
        {
            get { return pThisLocation; }
            set { pThisLocation = value; }
        }
		
		private string pThisPrefix = "";
//		private string pThisPrefix = @"bmlevels2";
//		[Display(ResourceType = typeof(Custom.Resource), Name = "File Name", GroupName = "Parameters", Order = 31)]
//        public string ThisPrefix
//        {
//            get { return pThisPrefix; }
//            set { pThisPrefix = value; }
//        }

		
		

        private int pMinutesToUpdate = 5;
        [Range(1, int.MaxValue)]
        [Display(ResourceType = typeof(Custom.Resource), Name = "Update Frequency (Minutes)", GroupName = "Parameters", Order = 55)]
        public int MinutesToUpdate
        {
            get { return pMinutesToUpdate; }
            set { pMinutesToUpdate = value; }
        }		
		
		
		
        private bool pUseIName = false;
//        [Display(ResourceType = typeof(Custom.Resource), Name = "Use Instrument Name", Description = "", GroupName = "Parameters", Order = 3)]
//        public bool UseIName
//        {
//            get { return pUseIName; }
//            set { pUseIName = value; }
//        }	
		
        private bool pUseNinjaDir = false;
//        [Display(ResourceType = typeof(Custom.Resource), Name = "Use Default Location", Description = "", GroupName = "Parameters", Order = 4)]
//        public bool UseNinjaDir
//        {
//            get { return pUseNinjaDir; }
//            set { pUseNinjaDir = value; }
//        }	
				
		
		
	}
	
	
	
	
		// Hide UserDefinedValues properties when not in use by the HLCCalculationMode.UserDefinedValues
	// When creating a custom type converter for indicators it must inherit from NinjaTrader.NinjaScript.IndicatorBaseConverter to work correctly with indicators
	public class SpotGammaConverter : NinjaTrader.NinjaScript.IndicatorBaseConverter
	{
		public override bool GetPropertiesSupported(ITypeDescriptorContext context) { return true; }

		public override PropertyDescriptorCollection GetProperties(ITypeDescriptorContext context, object value, Attribute[] attributes)
		{
			PropertyDescriptorCollection propertyDescriptorCollection = base.GetPropertiesSupported(context) ? base.GetProperties(context, value, attributes) : TypeDescriptor.GetProperties(value, attributes);

			SpotGamma   jbb = (SpotGamma) value;
			
			//Pivots						thisPivotsInstance			= (Pivots) value;
			
			//bool MagnetsOn = ;
			
			List<string> DeleteThese = new List<string>();
			List<string> DeleteThese2 = new List<string>();
			
	
		  
		  DeleteThese.Add("TimeSlicedLeftoverAction");
				
		    if (jbb.TimeSlicedLeftoverAction == "Web")
			{	
				DeleteThese.Add("ThisLocation");
				
			}	        
      	  else
			{
				DeleteThese.Add("WebLocation");
			}
			
	
			
			DeleteThese.Add("Calculate");
			DeleteThese.Add("Name");
      		DeleteThese.Add("MaximumBarsLookBack");
			
			DeleteThese.Add("Input");
			
			//DeleteThese.Add("IsAutoScale");
			DeleteThese.Add("Displacement");
			//DeleteThese.Add("DisplayInDataBox");
			DeleteThese.Add("Panel");
			//DeleteThese.Add("PaintPriceMarkers");
			DeleteThese.Add("ScaleJustification");
			DeleteThese.Add("IsVisible");
			
			
			
			
		
		
	

		
		
		
		
		
		
			
//      	DeleteThese2.Add("Calculate");
//			DeleteThese2.Add("Label");
//			DeleteThese2.Add("Maximum bars look back");
//			DeleteThese2.Add("Input series");
			

			
			if (DeleteThese.Count == 0 && DeleteThese2.Count == 0)
				return propertyDescriptorCollection;

			
		
			
			
			PropertyDescriptorCollection adjusted = new PropertyDescriptorCollection(null);
			foreach (PropertyDescriptor thisDescriptor in propertyDescriptorCollection)
			{
				
				
				//Print("asdsa");
				
//				if (thisDescriptor.Category.ToString() != "Iceberg Entry Orders")
//					adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				
//				CategoryItem CI = thisDescriptor.cate;
				
					
//				if (!jbb.NewFeaturesEnabled)
//				if (thisDescriptor.Description.ToString().Contains("Market Depth Display"))
//					adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				
				
				if (DeleteThese.Contains(thisDescriptor.Name))
					adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				
//				else if (DeleteThese2.Contains(thisDescriptor.DisplayName))	
//					adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				
				else if (thisDescriptor.Category == "Data Series")	
					adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				else
					adjusted.Add(thisDescriptor);
				
				//adjusted.Add(new PropertyDescriptorExtended(thisDescriptor, o => value, null, new Attribute[] {new BrowsableAttribute(false), }));
				
			}
			
			
//			foreach (CategoryItem CI in propertyGrid.Categories)
//				{
				
//					if (DeleteThese.Contains(CI.Name))
//					{
						
						
						
//						//Print(CI.Name);
						
						
//					}
//					else
//					{
//						//CI.IsBrowsable = false;
//						CI.IsExpanded = false;
//					}
					
//				}
				
				
				
						
//				foreach (CategoryItem CI in propertyDescriptorCollection.cate.cat.Categories)
//				{
				
//					if (DeleteThese.Contains(CI.Name))
//					{
						
						
						
//						//Print(CI.Name);
						
						
//					}
//					else
//					{
//						CI.IsBrowsable = false;
//						//CI.IsExpanded = false;
//					}
					
//				}
				
				
			return adjusted;
			
			
		
			
		}
	}
	
	
	
	
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpotGamma[] cacheSpotGamma;
		public SpotGamma SpotGamma()
		{
			return SpotGamma(Input);
		}

		public SpotGamma SpotGamma(ISeries<double> input)
		{
			if (cacheSpotGamma != null)
				for (int idx = 0; idx < cacheSpotGamma.Length; idx++)
					if (cacheSpotGamma[idx] != null &&  cacheSpotGamma[idx].EqualsInput(input))
						return cacheSpotGamma[idx];
			return CacheIndicator<SpotGamma>(new SpotGamma(), input, ref cacheSpotGamma);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpotGamma SpotGamma()
		{
			return indicator.SpotGamma(Input);
		}

		public Indicators.SpotGamma SpotGamma(ISeries<double> input )
		{
			return indicator.SpotGamma(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpotGamma SpotGamma()
		{
			return indicator.SpotGamma(Input);
		}

		public Indicators.SpotGamma SpotGamma(ISeries<double> input )
		{
			return indicator.SpotGamma(input);
		}
	}
}

#endregion
